Index: src/datacreator.cpp
===================================================================
--- src/datacreator.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/datacreator.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -399,24 +519,24 @@
  * Results are stored in the matrix ForceMatrix::MatrixCounter of \a Force.
  * \param Force ForceMatrix class containing matrix values
-	* \param MatrixNumber the index for the ForceMatrix::matrix array
+  * \param MatrixNumber the index for the ForceMatrix::matrix array
  */
 void CreateMeanForce(class MatrixContainer &Force, int MatrixNumber)
 {
-	int divisor = 0;
-	for (int l=Force.ColumnCounter;l--;)
-		Force.Matrix[MatrixNumber][ Force.RowCounter[MatrixNumber] ][l] = 0.;
-	for (int l=5;l<Force.ColumnCounter;l+=3) {
-		double tmp = 0;
-		for (int k=Force.RowCounter[MatrixNumber];k--;) {
-			double norm = 0.;
-			for (int m=NDIM;m--;)
-				norm += Force.Matrix[MatrixNumber][ k ][l+m]
-							* Force.Matrix[MatrixNumber][ k ][l+m];
-			tmp += sqrt(norm);
-			if (fabs(norm) > MYEPSILON) divisor++;
-		}
-		tmp /= (double)divisor;
-		Force.Matrix[MatrixNumber][ Force.RowCounter[MatrixNumber] ][l] = tmp;
-	}
+  int divisor = 0;
+  for (int l=Force.ColumnCounter[MatrixNumber];l--;)
+    Force.Matrix[MatrixNumber][ Force.RowCounter[MatrixNumber] ][l] = 0.;
+  for (int l=5;l<Force.ColumnCounter[MatrixNumber];l+=3) {
+    double tmp = 0;
+    for (int k=Force.RowCounter[MatrixNumber];k--;) {
+      double norm = 0.;
+      for (int m=NDIM;m--;)
+        norm += Force.Matrix[MatrixNumber][ k ][l+m]
+              * Force.Matrix[MatrixNumber][ k ][l+m];
+      tmp += sqrt(norm);
+      if (fabs(norm) > MYEPSILON) divisor++;
+    }
+    tmp /= (double)divisor;
+    Force.Matrix[MatrixNumber][ Force.RowCounter[MatrixNumber] ][l] = tmp;
+  }
 };
 
@@ -428,18 +548,18 @@
 void CreateMaximumForce(class MatrixContainer &Force, int MatrixNumber)
 {
-	for (int l=5;l<Force.ColumnCounter;l+=3) {
-		double stored = 0;
-		for (int k=Force.RowCounter[MatrixNumber];k--;) {
-			double tmp = 0;
-			for (int m=NDIM;m--;)
-				tmp += Force.Matrix[MatrixNumber][ k ][l+m]
-							* Force.Matrix[MatrixNumber][ k ][l+m];
-			if (tmp > stored) {	// current force is greater than stored
-				for (int m=NDIM;m--;)
-					Force.Matrix[MatrixNumber][ Force.RowCounter[MatrixNumber] ][l+m]	= Force.Matrix[MatrixNumber][ k ][l+m];
-				stored = tmp;
-			}
-		}
-	}
+  for (int l=5;l<Force.ColumnCounter[MatrixNumber];l+=3) {
+    double stored = 0;
+    for (int k=Force.RowCounter[MatrixNumber];k--;) {
+      double tmp = 0;
+      for (int m=NDIM;m--;)
+        tmp += Force.Matrix[MatrixNumber][ k ][l+m]
+              * Force.Matrix[MatrixNumber][ k ][l+m];
+      if (tmp > stored) {  // current force is greater than stored
+        for (int m=NDIM;m--;)
+          Force.Matrix[MatrixNumber][ Force.RowCounter[MatrixNumber] ][l+m]  = Force.Matrix[MatrixNumber][ k ][l+m];
+        stored = tmp;
+      }
+    }
+  }
 };
 
@@ -450,5 +570,5 @@
 void CreateSameForce(class MatrixContainer &Force, int MatrixNumber)
 {
-	// does nothing
+  // does nothing
 };
 
@@ -460,10 +580,10 @@
 void CreateVectorSumForce(class MatrixContainer &Force, int MatrixNumber)
 {
-	for (int l=Force.ColumnCounter;l--;)
-		Force.Matrix[MatrixNumber][ Force.RowCounter[MatrixNumber] ][l] = 0.;
-	for (int l=0;l<Force.ColumnCounter;l++) {
-		for (int k=Force.RowCounter[MatrixNumber];k--;)
-			Force.Matrix[MatrixNumber][ Force.RowCounter[MatrixNumber] ][l] += Force.Matrix[MatrixNumber][k][l];
-	}
+  for (int l=Force.ColumnCounter[MatrixNumber];l--;)
+    Force.Matrix[MatrixNumber][ Force.RowCounter[MatrixNumber] ][l] = 0.;
+  for (int l=0;l<Force.ColumnCounter[MatrixNumber];l++) {
+    for (int k=Force.RowCounter[MatrixNumber];k--;)
+      Force.Matrix[MatrixNumber][ Force.RowCounter[MatrixNumber] ][l] += Force.Matrix[MatrixNumber][k][l];
+  }
 };
 
@@ -480,18 +600,18 @@
 void CreatePlotHeader(ofstream &output, const char *prefix, const int keycolumns, const char *key, const char *logscale, const char *extraline, const int mxtics, const int xtics, const char *xlabel, const char *ylabel)
 {
-	//output << "#!/home/heber/build/pyxplot/pyxplot" << endl << endl;
-	output << "reset" << endl;
-	output << "set keycolumns "<< keycolumns << endl;
-	output << "set key " << key << endl;
-	output << "set mxtics "<< mxtics << endl;
-	output << "set xtics "<< xtics << endl;
-	if (logscale != NULL)
-		output << "set logscale " << logscale << endl;
-	if (extraline != NULL)
-		output << extraline << endl;
-	output << "set xlabel '" << xlabel << "'" << endl;
-	output << "set ylabel '" << ylabel << "'" << endl;
-	output << "set terminal eps color" << endl;
-	output << "set output '"<< prefix << ".eps'" << endl;
+  //output << "#!/home/heber/build/pyxplot/pyxplot" << endl << endl;
+  output << "reset" << endl;
+  output << "set keycolumns "<< keycolumns << endl;
+  output << "set key " << key << endl;
+  output << "set mxtics "<< mxtics << endl;
+  output << "set xtics "<< xtics << endl;
+  if (logscale != NULL)
+    output << "set logscale " << logscale << endl;
+  if (extraline != NULL)
+    output << extraline << endl;
+  output << "set xlabel '" << xlabel << "'" << endl;
+  output << "set ylabel '" << ylabel << "'" << endl;
+  output << "set terminal eps color" << endl;
+  output << "set output '"<< prefix << ".eps'" << endl;
 };
 
@@ -517,14 +637,14 @@
 bool CreatePlotOrder(class MatrixContainer &Matrix, const class KeySetsContainer &KeySet, const char *dir, const char *prefix, const int keycolumns, const char *key, const char *logscale, const char *extraline, const int mxtics, const int xtics, const char *xlabel, const char *ylabel, const char *xrange, const char *yrange, const char *xargument, const char *uses, void (*CreatePlotLines)(ofstream &, class MatrixContainer &, const char *, const char *, const char *))
 {
-	stringstream filename;
-	ofstream output;
-
-	filename << prefix << ".pyx";
-	if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
-	CreatePlotHeader(output, prefix, keycolumns, key, logscale, extraline, mxtics, xtics, xlabel, ylabel);
-	output << "plot " << xrange << " " << yrange << " \\" << endl;
-	CreatePlotLines(output, Matrix, prefix, xargument, uses);
-	output.close();
-	return true;
+  stringstream filename;
+  ofstream output;
+
+  filename << prefix << ".pyx";
+  if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
+  CreatePlotHeader(output, prefix, keycolumns, key, logscale, extraline, mxtics, xtics, xlabel, ylabel);
+  output << "plot " << xrange << " " << yrange << " \\" << endl;
+  CreatePlotLines(output, Matrix, prefix, xargument, uses);
+  output.close();
+  return true;
 };
 
@@ -538,17 +658,17 @@
 void AbsEnergyPlotLine(ofstream &output, class MatrixContainer &Energy, const char *prefix, const char *xargument, const char *uses)
 {
-	stringstream line(Energy.Header);
-	string token;
-
-	getline(line, token, '\t');
-	for (int i=2; i<= Energy.ColumnCounter;i++) {
-		getline(line, token, '\t');
-		while (token[0] == ' ') // remove leading white spaces
-			token.erase(0,1);
-		output << "'" << prefix << ".dat' title '" << token << "' using " << xargument << ":(abs($" << i+2 << ")) " << uses;
-		if (i != (Energy.ColumnCounter))
-			output << ", \\";
-		output << endl;
-	}
+  stringstream line(Energy.Header[ Energy.MatrixCounter ]);
+  string token;
+
+  getline(line, token, '\t');
+  for (int i=2; i<= Energy.ColumnCounter[Energy.MatrixCounter];i++) {
+    getline(line, token, '\t');
+    while (token[0] == ' ') // remove leading white spaces
+      token.erase(0,1);
+    output << "'" << prefix << ".dat' title '" << token << "' using " << xargument << ":(abs($" << i+2 << ")) " << uses;
+    if (i != (Energy.ColumnCounter[Energy.MatrixCounter]))
+      output << ", \\";
+    output << endl;
+  }
 };
 
@@ -562,17 +682,17 @@
 void EnergyPlotLine(ofstream &output, class MatrixContainer &Energy, const char *prefix, const char *xargument, const char *uses)
 {
-	stringstream line(Energy.Header);
-	string token;
-
-	getline(line, token, '\t');
-	for (int i=1; i<= Energy.ColumnCounter;i++) {
-		getline(line, token, '\t');
-		while (token[0] == ' ') // remove leading white spaces
-			token.erase(0,1);
-		output << "'" << prefix << ".dat' title '" << token << "' using " << xargument << ":" << i+2 << " " << uses;
-		if (i != (Energy.ColumnCounter))
-			output << ", \\";
-		output << endl;
-	}
+  stringstream line(Energy.Header[Energy.MatrixCounter]);
+  string token;
+
+  getline(line, token, '\t');
+  for (int i=1; i<= Energy.ColumnCounter[Energy.MatrixCounter];i++) {
+    getline(line, token, '\t');
+    while (token[0] == ' ') // remove leading white spaces
+      token.erase(0,1);
+    output << "'" << prefix << ".dat' title '" << token << "' using " << xargument << ":" << i+2 << " " << uses;
+    if (i != (Energy.ColumnCounter[Energy.MatrixCounter]))
+      output << ", \\";
+    output << endl;
+  }
 };
 
@@ -586,24 +706,24 @@
 void ForceMagnitudePlotLine(ofstream &output, class MatrixContainer &Force, const char *prefix, const char *xargument, const char *uses)
 {
-	stringstream line(Force.Header);
-	string token;
-
-	getline(line, token, '\t');
-	getline(line, token, '\t');
-	getline(line, token, '\t');
-	getline(line, token, '\t');
-	getline(line, token, '\t');
-	for (int i=7; i< Force.ColumnCounter;i+=NDIM) {
-		getline(line, token, '\t');
-		while (token[0] == ' ') // remove leading white spaces
-			token.erase(0,1);
-		token.erase(token.length(), 1);	// kill residual index char (the '0')
-		output << "'" << prefix << ".dat' title '" << token << "' using " << xargument << ":(sqrt($" << i+1 << "*$" << i+1 << "+$" << i+2 << "*$" << i+2 << "+$" << i+3 << "*$" << i+3 << ")) " << uses;
-		if (i != (Force.ColumnCounter-1))
-			output << ", \\";
-		output << endl;
-		getline(line, token, '\t');
-		getline(line, token, '\t');
-	}
+  stringstream line(Force.Header[Force.MatrixCounter]);
+  string token;
+
+  getline(line, token, '\t');
+  getline(line, token, '\t');
+  getline(line, token, '\t');
+  getline(line, token, '\t');
+  getline(line, token, '\t');
+  for (int i=7; i< Force.ColumnCounter[Force.MatrixCounter];i+=NDIM) {
+    getline(line, token, '\t');
+    while (token[0] == ' ') // remove leading white spaces
+      token.erase(0,1);
+    token.erase(token.length(), 1);  // kill residual index char (the '0')
+    output << "'" << prefix << ".dat' title '" << token << "' using " << xargument << ":(sqrt($" << i+1 << "*$" << i+1 << "+$" << i+2 << "*$" << i+2 << "+$" << i+3 << "*$" << i+3 << ")) " << uses;
+    if (i != (Force.ColumnCounter[Force.MatrixCounter]-1))
+      output << ", \\";
+    output << endl;
+    getline(line, token, '\t');
+    getline(line, token, '\t');
+  }
 };
 
@@ -617,24 +737,24 @@
 void AbsFirstForceValuePlotLine(ofstream &output, class MatrixContainer &Force, const char *prefix, const char *xargument, const char *uses)
 {
-	stringstream line(Force.Header);
-	string token;
-
-	getline(line, token, '\t');
-	getline(line, token, '\t');
-	getline(line, token, '\t');
-	getline(line, token, '\t');
-	getline(line, token, '\t');
-	for (int i=7; i< Force.ColumnCounter;i+=NDIM) {
-		getline(line, token, '\t');
-		while (token[0] == ' ') // remove leading white spaces
-			token.erase(0,1);
-		token.erase(token.length(), 1);	// kill residual index char (the '0')
-		output << "'" << prefix << ".dat' title '" << token << "' using " << xargument << ":(abs($" << i+1 << ")) " << uses;
-		if (i != (Force.ColumnCounter-1))
-			output << ", \\";
-		output << endl;
-		getline(line, token, '\t');
-		getline(line, token, '\t');
-	}
+  stringstream line(Force.Header[Force.MatrixCounter]);
+  string token;
+
+  getline(line, token, '\t');
+  getline(line, token, '\t');
+  getline(line, token, '\t');
+  getline(line, token, '\t');
+  getline(line, token, '\t');
+  for (int i=7; i< Force.ColumnCounter[Force.MatrixCounter];i+=NDIM) {
+    getline(line, token, '\t');
+    while (token[0] == ' ') // remove leading white spaces
+      token.erase(0,1);
+    token.erase(token.length(), 1);  // kill residual index char (the '0')
+    output << "'" << prefix << ".dat' title '" << token << "' using " << xargument << ":(abs($" << i+1 << ")) " << uses;
+    if (i != (Force.ColumnCounter[Force.MatrixCounter]-1))
+      output << ", \\";
+    output << endl;
+    getline(line, token, '\t');
+    getline(line, token, '\t');
+  }
 };
 
@@ -648,25 +768,25 @@
 void BoxesForcePlotLine(ofstream &output, class MatrixContainer &Force, const char *prefix, const char *xargument, const char *uses)
 {
-	stringstream line(Force.Header);
-	const char *fillcolor[5] = {"black", "red", "blue", "green", "cyan"};
-	string token;
-
-	getline(line, token, '\t');
-	getline(line, token, '\t');
-	getline(line, token, '\t');
-	getline(line, token, '\t');
-	getline(line, token, '\t');
-	for (int i=7; i< Force.ColumnCounter;i+=NDIM) {
-		getline(line, token, '\t');
-		while (token[0] == ' ') // remove leading white spaces
-			token.erase(0,1);
-		token.erase(token.length(), 1);	// kill residual index char (the '0')
-		output << "'" << prefix << ".dat' title '" << token << "' using ($" << xargument << "+" << fixed << setprecision(1) << (double)((i-7)/3)*0.2 << "):(sqrt($" << i+1 << "*$" << i+1 << "+$" << i+2 << "*$" << i+2 << "+$" << i+3 << "*$" << i+3 << ")) " << uses << " " << fillcolor[(i-7)/3];
-		if (i != (Force.ColumnCounter-1))
-			output << ", \\";
-		output << endl;
-		getline(line, token, '\t');
-		getline(line, token, '\t');
-	}
+  stringstream line(Force.Header[Force.MatrixCounter]);
+  char *fillcolor[5] = {"black", "red", "blue", "green", "cyan"};
+  string token;
+
+  getline(line, token, '\t');
+  getline(line, token, '\t');
+  getline(line, token, '\t');
+  getline(line, token, '\t');
+  getline(line, token, '\t');
+  for (int i=7; i< Force.ColumnCounter[Force.MatrixCounter];i+=NDIM) {
+    getline(line, token, '\t');
+    while (token[0] == ' ') // remove leading white spaces
+      token.erase(0,1);
+    token.erase(token.length(), 1);  // kill residual index char (the '0')
+    output << "'" << prefix << ".dat' title '" << token << "' using ($" << xargument << "+" << fixed << setprecision(1) << (double)((i-7)/3)*0.2 << "):(sqrt($" << i+1 << "*$" << i+1 << "+$" << i+2 << "*$" << i+2 << "+$" << i+3 << "*$" << i+3 << ")) " << uses << " " << fillcolor[(i-7)/3];
+    if (i != (Force.ColumnCounter[Force.MatrixCounter]-1))
+      output << ", \\";
+    output << endl;
+    getline(line, token, '\t');
+    getline(line, token, '\t');
+  }
 };
 
@@ -680,24 +800,24 @@
 void BoxesFirstForceValuePlotLine(ofstream &output, class MatrixContainer &Force, const char *prefix, const char *xargument, const char *uses)
 {
-	stringstream line(Force.Header);
-	const char *fillcolor[5] = {"black", "red", "blue", "green", "cyan"};
-	string token;
-
-	getline(line, token, '\t');
-	getline(line, token, '\t');
-	getline(line, token, '\t');
-	getline(line, token, '\t');
-	getline(line, token, '\t');
-	for (int i=7; i< Force.ColumnCounter;i+=NDIM) {
-		getline(line, token, '\t');
-		while (token[0] == ' ') // remove leading white spaces
-			token.erase(0,1);
-		token.erase(token.length(), 1);	// kill residual index char (the '0')
-		output << "'" << prefix << ".dat' title '" << token << "' using ($" << xargument << "+" << fixed << setprecision(1) << (double)((i-7)/3)*0.2 << "):" << i+1 << " " << uses << " " << fillcolor[(i-7)/3];
-		if (i != (Force.ColumnCounter-1))
-			output << ", \\";
-		output << endl;
-		getline(line, token, '\t');
-		getline(line, token, '\t');
-	}
-};
+  stringstream line(Force.Header[Force.MatrixCounter]);
+  char *fillcolor[5] = {"black", "red", "blue", "green", "cyan"};
+  string token;
+
+  getline(line, token, '\t');
+  getline(line, token, '\t');
+  getline(line, token, '\t');
+  getline(line, token, '\t');
+  getline(line, token, '\t');
+  for (int i=7; i< Force.ColumnCounter[Force.MatrixCounter];i+=NDIM) {
+    getline(line, token, '\t');
+    while (token[0] == ' ') // remove leading white spaces
+      token.erase(0,1);
+    token.erase(token.length(), 1);  // kill residual index char (the '0')
+    output << "'" << prefix << ".dat' title '" << token << "' using ($" << xargument << "+" << fixed << setprecision(1) << (double)((i-7)/3)*0.2 << "):" << i+1 << " " << uses << " " << fillcolor[(i-7)/3];
+    if (i != (Force.ColumnCounter[Force.MatrixCounter]-1))
+      output << ", \\";
+    output << endl;
+    getline(line, token, '\t');
+    getline(line, token, '\t');
+  }
+};
Index: src/datacreator.hpp
===================================================================
--- src/datacreator.hpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/datacreator.hpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -25,5 +25,8 @@
 bool CreateDataForcesOrderPerAtom(class ForceMatrix &Fragments, class KeySetsContainer &KeySet, const char *dir, const char *prefix, const char *msg, const char *datum);
 bool CreateDataDeltaForcesOrder(class ForceMatrix &Force, class ForceMatrix &Fragments, class KeySetsContainer &KeySet, const char *dir, const char *prefix, const char *msg, const char *datum, void (*CreateForce)(class MatrixContainer &, int));
-bool CreateDataDeltaForcesOrderPerAtom(class ForceMatrix &Force, class ForceMatrix &Fragments, class KeySetsContainer &KeySet, const char *dir, const char *prefix, const char *msg, const char *datum);
+bool CreateDataDeltaForcesOrderPerAtom(class ForceMatrix &Force, class ForceMatrix &Fragments, class KeySetsContainer &KeySet, const char *dir, const char *prefix, const char *msg, const char *datum); 
+bool CreateDataHessianOrderPerAtom(class HessianMatrix &Fragments, class KeySetsContainer &KeySet, const char *dir, const char *prefix, const char *msg, const char *datum); 
+bool CreateDataDeltaHessianOrderPerAtom(class HessianMatrix &Hessian, class HessianMatrix &Fragments, class KeySetsContainer &KeySet, const char *dir, const char *prefix, const char *msg, const char *datum); 
+bool CreateDataDeltaFrobeniusOrderPerAtom(class HessianMatrix &Hessian, class HessianMatrix &Fragments, class KeySetsContainer &KeySet, const char *dir, const char *prefix, const char *msg, const char *datum); 
 bool CreateDataFragment(class MatrixContainer &ForceFragments, class KeySetsContainer &KeySet, const char *dir, const char *prefix, const char *msg, const char *datum, void (*CreateForce)(class MatrixContainer &, int));
 bool CreateDataFragmentOrder(class MatrixContainer &Fragment, class KeySetsContainer &KeySet, const char *dir, const char *prefix, const char *msg, const char *datum, void (*CreateFragmentOrder)(class MatrixContainer &, class KeySetsContainer &, int));
Index: src/defs.hpp
===================================================================
--- src/defs.hpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/defs.hpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -10,10 +10,19 @@
 using namespace std;
 
-#define MYEPSILON 1e-13	 //!< machine epsilon precision
-#define NDIM	3	 //!< number of spatial dimensions
-#define MAX_ELEMENTS 128	//!< maximum number of elements for certain lookup tables 
-#define AtomicLengthToAngstroem	0.52917721 //!< conversion factor from atomic length/bohrradius to angstroem
-#define BONDTHRESHOLD 0.5	 //!< CSD threshold in bond check which is the width of the interval whose center is the sum of the covalent radii 
-#define AtomicEnergyToKelvin 315774.67	//!< conversion factor from atomic energy to kelvin via boltzmann factor
+#define MYEPSILON 1e-13   //!< machine epsilon precision
+#define NDIM  3   //!< number of spatial dimensions
+#define MAX_ELEMENTS 128  //!< maximum number of elements for certain lookup tables 
+#define AtomicLengthToAngstroem  0.52917721 //!< conversion factor from atomic length/bohrradius to angstroem
+#define BONDTHRESHOLD 0.5   //!< CSD threshold in bond check which is the width of the interval whose center is the sum of the covalent radii 
+#define AtomicEnergyToKelvin 315774.67  //!< conversion factor from atomic energy to kelvin via boltzmann factor
+#define KelvinToAtomicTemperature 3.1668152e-06    //!< conversion factor for Kelvin to atomic temperature (Hartree over k_B)
+#define KelvinToeV 8.6173422e-05                   //!< conversion factor for Kelvin to Ht (k_B * T = energy), thus Boltzmann constant in eV/K
+#define AtomicMassUnitsToeV 931494088.        //!< conversion factor for atomic weight in units to mass in eV
+#define AtomicMassUnitsToHt 34480864.        //!< conversion factor for atomic weight in units to mass in Ht (protonmass/electronmass * electron_mass_in_Ht
+#define ElectronMass_Ht 18778.865            //!< electron mass in Ht
+#define ElectronMass_eV 510998.903           //!< electron mass in eV
+#define Units2Electronmass (AtomicMassUnitsToeV/ElectronMass_eV) //!< atomic mass unit in eV/ electron mass in eV = 1 822.88863
+#define Atomictime2Femtoseconds 0.024188843     //!< Atomictime in fs
+
 #define VERSIONSTRING "v1.0"
 
@@ -24,12 +33,12 @@
 enum EdgeType { Undetermined, TreeEdge, BackEdge }; //!< edge type in a graph after Depth-First-Search analysis.
 
-enum Shading { white, lightgray, darkgray, black };	//!< color in Breadth-First-Search analysis
+enum Shading { white, lightgray, darkgray, black };  //!< color in Breadth-First-Search analysis
 
-//enum CutCyclicBond { KeepBond,	SaturateBond }; //!< Saturation scheme either atom- or bondwise 
+//enum CutCyclicBond { KeepBond,  SaturateBond }; //!< Saturation scheme either atom- or bondwise 
 
 // Specifting whether a value in the parameter file must be specified or is optional
-enum necessity { optional,		//!< parameter is optional, if not given sensible value is chosen
-								 critical		 //!< parameter must be given or programme won't initiate
-							 };
+enum necessity { optional,    //!< parameter is optional, if not given sensible value is chosen
+                 critical     //!< parameter must be given or programme won't initiate
+               };
 
 // Specifying the status of the on command line given config file
@@ -43,23 +52,23 @@
 
 // various standard filenames
-#define DEFAULTCONFIG "main_pcp_linux"		//!< default filename of config file
-#define CONVEXENVELOPE "ConvexEnvelope.dat"		//!< default filename of convex envelope tecplot data file
-#define KEYSETFILE "KeySets.dat"		//!< default filename of BOSSANOVA key sets file
-#define ADJACENCYFILE "Adjacency.dat"		//!< default filename of BOSSANOVA adjacancy file
-#define TEFACTORSFILE "TE-Factors.dat"		//!< default filename of BOSSANOVA total energy factors file
-#define FORCESFILE "Forces-Factors.dat"		//!< default filename of BOSSANOVA force factors file
-#define HCORRECTIONSUFFIX "Hcorrection.dat"		//!< default filename of BOSSANOVA H correction file (unwanted saturation interaction)
-#define FITCONSTANTSUFFIX "FitConstant.dat"	 //!< suffix of default filename of BOSSANOVA fit constants file (unwanted saturation interaction)
-#define SHIELDINGSUFFIX "sigma_all.csv"								//!< default filename of BOSSANOVA shieldings file
-#define SHIELDINGPASSUFFIX "sigma_all_PAS.csv"								 //!< default filename of BOSSANOVA shieldings PAS file
-#define ORDERATSITEFILE "OrderAtSite.dat"		//!< default filename of BOSSANOVA Bond Order at each atom file
-#define ENERGYPERFRAGMENT "EnergyPerFragment"		//!< default filename of BOSSANOVA Energy contribution Per Fragment file
-#define FRAGMENTPREFIX "BondFragment"		//!< default filename prefix of BOSSANOVA fragment config and directories 
-#define STANDARDCONFIG "unknown.conf"		//!< default filename of standard config file
-#define STANDARDELEMENTSDB "elements.db"		//!< default filename of elements data base with masses, Z, VanDerWaals radii, ...
-#define STANDARDVALENCEDB "valence.db"		//!< default filename of valence number per element database
-#define STANDARDORBITALDB "orbitals.db"		//!< default filename of orbitals per element database
-#define STANDARDHBONDDISTANCEDB "Hbonddistance.db"		//!< default filename of typial bond distance to hydrogen database
-#define STANDARDHBONDANGLEDB "Hbondangle.db"		//!< default filename of typial bond angle to hydrogen database
+#define DEFAULTCONFIG "main_pcp_linux"    //!< default filename of config file
+#define CONVEXENVELOPE "ConvexEnvelope.dat"    //!< default filename of convex envelope tecplot data file
+#define KEYSETFILE "KeySets.dat"    //!< default filename of BOSSANOVA key sets file
+#define ADJACENCYFILE "Adjacency.dat"    //!< default filename of BOSSANOVA adjacancy file
+#define TEFACTORSFILE "TE-Factors.dat"    //!< default filename of BOSSANOVA total energy factors file
+#define FORCESFILE "Forces-Factors.dat"    //!< default filename of BOSSANOVA force factors file
+#define HCORRECTIONSUFFIX "Hcorrection.dat"    //!< default filename of BOSSANOVA H correction file (unwanted saturation interaction)
+#define FITCONSTANTSUFFIX "FitConstant.dat"   //!< suffix of default filename of BOSSANOVA fit constants file (unwanted saturation interaction)
+#define SHIELDINGSUFFIX "sigma_all.csv"                //!< default filename of BOSSANOVA shieldings file
+#define SHIELDINGPASSUFFIX "sigma_all_PAS.csv"                 //!< default filename of BOSSANOVA shieldings PAS file
+#define ORDERATSITEFILE "OrderAtSite.dat"    //!< default filename of BOSSANOVA Bond Order at each atom file
+#define ENERGYPERFRAGMENT "EnergyPerFragment"    //!< default filename of BOSSANOVA Energy contribution Per Fragment file
+#define FRAGMENTPREFIX "BondFragment"    //!< default filename prefix of BOSSANOVA fragment config and directories 
+#define STANDARDCONFIG "unknown.conf"    //!< default filename of standard config file
+#define STANDARDELEMENTSDB "elements.db"    //!< default filename of elements data base with masses, Z, VanDerWaals radii, ...
+#define STANDARDVALENCEDB "valence.db"    //!< default filename of valence number per element database
+#define STANDARDORBITALDB "orbitals.db"    //!< default filename of orbitals per element database
+#define STANDARDHBONDDISTANCEDB "Hbonddistance.db"    //!< default filename of typial bond distance to hydrogen database
+#define STANDARDHBONDANGLEDB "Hbondangle.db"    //!< default filename of typial bond angle to hydrogen database
 
 // some values
@@ -68,5 +77,5 @@
 
 
-#define UPDATECOUNT 10	//!< update ten sites per BOSSANOVA interval
+#define UPDATECOUNT 10  //!< update ten sites per BOSSANOVA interval
 
 #endif /*DEFS_HPP_*/
Index: src/graph.cpp
===================================================================
--- src/graph.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/graph.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -7,10 +7,56 @@
 using namespace std;
 
+#include "graph.hpp"
 
-#include <iostream>
-#include <list>
-#include <vector>
+/***************************************** Implementations for graph classes ********************************/
 
-/***************************************** Functions for class graph ********************************/
+/** Constructor of class Graph.
+ */
+Graph::Graph()
+{
+};
 
+/** Destructor of class Graph.
+ * Destructor does release memory for nodes and edges contained in its lists as well.
+ */
+Graph::~Graph()
+{
+};
 
+/** Constructor of class SubGraph.
+ */
+SubGraph::SubGraph()
+{
+};
+
+/** Destructor of class SubGraph.
+ * Note that destructor does not deallocate either nodes or edges! (this is done by its subgraph!)
+ */
+SubGraph::~SubGraph()
+{
+};
+
+/** Constructor of class Node.
+ */
+Node::Node()
+{
+};
+
+/** Destructor of class Node.
+ */
+Node::~Node()
+{
+};
+
+/** Constructor of class Edge.
+ */
+Edge::Edge()
+{
+};
+
+/** Destructor of class Edge.
+ */
+Edge::~Edge()
+{
+};
+
Index: src/graph.hpp
===================================================================
--- src/graph.hpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
+++ src/graph.hpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -0,0 +1,68 @@
+/** \file graph.cpp
+ * 
+ * Function definitions for the class graph.
+ * 
+ */
+
+#ifndef GRAPH_HPP_
+#define GRAPH_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+// STL headers
+#include <map>
+#include <multimap>
+
+#include "molecules.hpp"
+
+class Graph;
+class SubGraph;
+class Node;
+class Edge;
+
+/***************************************** Various graph-related STL defines ********************************/
+
+#define NodeMap pair < int, class Node* >
+#define EdgeMap multimap < class Node*, class Edge* >
+
+/***************************************** Definition for classes ********************************/
+
+/** Graph class containing the graphs behind molecules.
+ */
+class Graph
+{
+	NodeMap ListOfNodes;		//!< tree-list of all nodes in this graph
+	EdgeMap ListOfEdges;		//!< tree-multi-list of all nodes, referenced to node id
+};
+
+/** Class describing subgraphs of the Class \a Graph.
+ * SubGraph has its own node and edge lists, however also a pointer to its father graph
+ * and hence access to its list as well. 
+ */
+class SubGraph : class Graph
+{
+	class Graph *FatherGraph;		//!< Graph whose subgraph we are
+};
+
+/** Class containing the nodes of a graph.
+ */
+class Node
+{
+	int	id;				//!< individual id of the node
+	char *Name;		//!< Name of the node for pretty printing
+};
+
+/** Class containing egdes in a Graph strructure.
+ */
+class Edge
+{
+	class Node *leftnode;		//!< pointer to first node
+	class Node *atomnode;		//!< pointer to second node
+};
+
+
+
+#endif /*GRAPH_HPP_*/
